/*!
  * vue-i18n-core v10.0.0-alpha.1
  * (c) 2024 kazuya kawaguchi
  * Released under the MIT License.
  */
import{createVNode,Text,computed,watch,getCurrentInstance,ref,shallowRef,Fragment,defineComponent,h,effectScope,inject,onMounted,onUnmounted,isRef}from"vue";const inBrowser="undefined"!=typeof window,makeSymbol=(e,t=!1)=>t?Symbol.for(e):Symbol(e),generateFormatCacheKey=(e,t,n)=>friendlyJSONstringify({l:e,k:t,s:n}),friendlyJSONstringify=e=>JSON.stringify(e).replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029").replace(/\u0027/g,"\\u0027"),isNumber=e=>"number"==typeof e&&isFinite(e),isDate=e=>"[object Date]"===toTypeString(e),isRegExp=e=>"[object RegExp]"===toTypeString(e),isEmptyObject=e=>isPlainObject(e)&&0===Object.keys(e).length,assign=Object.assign;function escapeHtml(e){return e.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&apos;")}const hasOwnProperty=Object.prototype.hasOwnProperty;function hasOwn(e,t){return hasOwnProperty.call(e,t)}const isArray=Array.isArray,isFunction=e=>"function"==typeof e,isString=e=>"string"==typeof e,isBoolean=e=>"boolean"==typeof e,isObject=e=>null!==e&&"object"==typeof e,isPromise=e=>isObject(e)&&isFunction(e.then)&&isFunction(e.catch),objectToString=Object.prototype.toString,toTypeString=e=>objectToString.call(e),isPlainObject=e=>{if(!isObject(e))return!1;const t=Object.getPrototypeOf(e);return null===t||t.constructor===Object},toDisplayString=e=>null==e?"":isArray(e)||isPlainObject(e)&&e.toString===objectToString?JSON.stringify(e,null,2):String(e);function join(e,t=""){return e.reduce(((e,n,a)=>0===a?e+n:e+t+n),"")}function incrementer(e){let t=e;return()=>++t}function warn(e,t){"undefined"!=typeof console&&(console.warn("[intlify] "+e),t&&console.warn(t.stack))}const isNotObjectOrIsArray=e=>!isObject(e)||isArray(e);function deepCopy(e,t){if(isNotObjectOrIsArray(e)||isNotObjectOrIsArray(t))throw new Error("Invalid value");const n=[{src:e,des:t}];for(;n.length;){const{src:e,des:t}=n.pop();Object.keys(e).forEach((a=>{isNotObjectOrIsArray(e[a])||isNotObjectOrIsArray(t[a])?t[a]=e[a]:n.push({src:e[a],des:t[a]})}))}}const CompileErrorCodes={EXPECTED_TOKEN:1,INVALID_TOKEN_IN_PLACEHOLDER:2,UNTERMINATED_SINGLE_QUOTE_IN_PLACEHOLDER:3,UNKNOWN_ESCAPE_SEQUENCE:4,INVALID_UNICODE_ESCAPE_SEQUENCE:5,UNBALANCED_CLOSING_BRACE:6,UNTERMINATED_CLOSING_BRACE:7,EMPTY_PLACEHOLDER:8,NOT_ALLOW_NEST_PLACEHOLDER:9,INVALID_LINKED_FORMAT:10,MUST_HAVE_MESSAGES_IN_PLURAL:11,UNEXPECTED_EMPTY_LINKED_MODIFIER:12,UNEXPECTED_EMPTY_LINKED_KEY:13,UNEXPECTED_LEXICAL_ANALYSIS:14,UNHANDLED_CODEGEN_NODE_TYPE:15,UNHANDLED_MINIFIER_NODE_TYPE:16,__EXTEND_POINT__:17};function createCompileError(e,t,n={}){const{domain:a,messages:r,args:s}=n,o=new SyntaxError(String(e));return o.code=e,t&&(o.location=t),o.domain=a,o}function resolveWithKeyValue(e,t){return isObject(e)?e[t]:null}const DEFAULT_MODIFIER=e=>e,DEFAULT_MESSAGE=e=>"",DEFAULT_MESSAGE_DATA_TYPE="text",DEFAULT_NORMALIZE=e=>0===e.length?"":join(e),DEFAULT_INTERPOLATE=toDisplayString;function pluralDefault(e,t){return e=Math.abs(e),2===t?e?e>1?1:0:1:e?Math.min(e,2):0}function getPluralIndex(e){const t=isNumber(e.pluralIndex)?e.pluralIndex:-1;return e.named&&(isNumber(e.named.count)||isNumber(e.named.n))?isNumber(e.named.count)?e.named.count:isNumber(e.named.n)?e.named.n:t:t}function normalizeNamed(e,t){t.count||(t.count=e),t.n||(t.n=e)}function createMessageContext(e={}){const t=e.locale,n=getPluralIndex(e),a=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?e.pluralRules[t]:pluralDefault,r=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?pluralDefault:void 0,s=e.list||[],o=e.named||{};isNumber(e.pluralIndex)&&normalizeNamed(n,o);function l(t){const n=isFunction(e.messages)?e.messages(t):!!isObject(e.messages)&&e.messages[t];return n||(e.parent?e.parent.message(t):DEFAULT_MESSAGE)}const i=isPlainObject(e.processor)&&isFunction(e.processor.normalize)?e.processor.normalize:DEFAULT_NORMALIZE,c=isPlainObject(e.processor)&&isFunction(e.processor.interpolate)?e.processor.interpolate:DEFAULT_INTERPOLATE,u={list:e=>s[e],named:e=>o[e],plural:e=>e[a(n,e.length,r)],linked:(t,...n)=>{const[a,r]=n;let s="text",o="";1===n.length?isObject(a)?(o=a.modifier||o,s=a.type||s):isString(a)&&(o=a||o):2===n.length&&(isString(a)&&(o=a||o),isString(r)&&(s=r||s));const i=l(t)(u),c="vnode"===s&&isArray(i)&&o?i[0]:i;return o?(m=o,e.modifiers?e.modifiers[m]:DEFAULT_MODIFIER)(c,s):c;var m},message:l,type:isPlainObject(e.processor)&&isString(e.processor.type)?e.processor.type:DEFAULT_MESSAGE_DATA_TYPE,interpolate:c,normalize:i,values:assign({},s,o)};return u}const code$1=CompileErrorCodes.__EXTEND_POINT__,inc$1=incrementer(code$1),CoreErrorCodes={INVALID_ARGUMENT:code$1,INVALID_DATE_ARGUMENT:inc$1(),INVALID_ISO_DATE_ARGUMENT:inc$1(),NOT_SUPPORT_NON_STRING_MESSAGE:inc$1(),NOT_SUPPORT_LOCALE_PROMISE_VALUE:inc$1(),NOT_SUPPORT_LOCALE_ASYNC_FUNCTION:inc$1(),NOT_SUPPORT_LOCALE_TYPE:inc$1(),__EXTEND_POINT__:inc$1()};function getLocale(e,t){return null!=t.locale?resolveLocale(t.locale):resolveLocale(e.locale)}let _resolveLocale;function resolveLocale(e){if(isString(e))return e;if(isFunction(e)){if(e.resolvedOnce&&null!=_resolveLocale)return _resolveLocale;if("Function"===e.constructor.name){const t=e();if(isPromise(t))throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_PROMISE_VALUE);return _resolveLocale=t}throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_ASYNC_FUNCTION)}throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_TYPE)}function fallbackWithSimple(e,t,n){return[...new Set([n,...isArray(t)?t:isObject(t)?Object.keys(t):isString(t)?[t]:[n]])]}function fallbackWithLocaleChain(e,t,n){const a=isString(n)?n:DEFAULT_LOCALE,r=e;r.__localeChainCache||(r.__localeChainCache=new Map);let s=r.__localeChainCache.get(a);if(!s){s=[];let e=[n];for(;isArray(e);)e=appendBlockToChain(s,e,t);const o=isArray(t)||!isPlainObject(t)?t:t.default?t.default:null;e=isString(o)?[o]:o,isArray(e)&&appendBlockToChain(s,e,!1),r.__localeChainCache.set(a,s)}return s}function appendBlockToChain(e,t,n){let a=!0;for(let r=0;r<t.length&&isBoolean(a);r++){const s=t[r];isString(s)&&(a=appendLocaleToChain(e,t[r],n))}return a}function appendLocaleToChain(e,t,n){let a;const r=t.split("-");do{a=appendItemToChain(e,r.join("-"),n),r.splice(-1,1)}while(r.length&&!0===a);return a}function appendItemToChain(e,t,n){let a=!1;if(!e.includes(t)&&(a=!0,t)){a="!"!==t[t.length-1];const r=t.replace(/!/g,"");e.push(r),(isArray(n)||isPlainObject(n))&&n[r]&&(a=n[r])}return a}const VERSION$1="10.0.0-alpha.1",NOT_REOSLVED=-1,DEFAULT_LOCALE="en-US",MISSING_RESOLVE_VALUE="",capitalize=e=>`${e.charAt(0).toLocaleUpperCase()}${e.substr(1)}`;function getDefaultLinkedModifiers(){return{upper:(e,t)=>"text"===t&&isString(e)?e.toUpperCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toUpperCase():e,lower:(e,t)=>"text"===t&&isString(e)?e.toLowerCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toLowerCase():e,capitalize:(e,t)=>"text"===t&&isString(e)?capitalize(e):"vnode"===t&&isObject(e)&&"__v_isVNode"in e?capitalize(e.children):e}}let _compiler,_resolver,_fallbacker;const setAdditionalMeta=e=>{};let _fallbackContext=null;const setFallbackContext=e=>{_fallbackContext=e},getFallbackContext=()=>_fallbackContext;let _cid=0;function createCoreContext(e={}){const t=isFunction(e.onWarn)?e.onWarn:warn,n=isString(e.version)?e.version:VERSION$1,a=isString(e.locale)||isFunction(e.locale)?e.locale:DEFAULT_LOCALE,r=isFunction(a)?DEFAULT_LOCALE:a,s=isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||isString(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:r,o=isPlainObject(e.messages)?e.messages:{[r]:{}},l=isPlainObject(e.datetimeFormats)?e.datetimeFormats:{[r]:{}},i=isPlainObject(e.numberFormats)?e.numberFormats:{[r]:{}},c=assign({},e.modifiers||{},getDefaultLinkedModifiers()),u=e.pluralRules||{},m=isFunction(e.missing)?e.missing:null,g=!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,_=!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,p=!!e.fallbackFormat,f=!!e.unresolving,b=isFunction(e.postTranslation)?e.postTranslation:null,E=isPlainObject(e.processor)?e.processor:null,d=!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,O=!!e.escapeParameter,T=isFunction(e.messageCompiler)?e.messageCompiler:_compiler,N=isFunction(e.messageResolver)?e.messageResolver:_resolver||resolveWithKeyValue,S=isFunction(e.localeFallbacker)?e.localeFallbacker:_fallbacker||fallbackWithSimple,F=isObject(e.fallbackContext)?e.fallbackContext:void 0,I=e,y=isObject(I.__datetimeFormatters)?I.__datetimeFormatters:new Map,L=isObject(I.__numberFormatters)?I.__numberFormatters:new Map,C=isObject(I.__meta)?I.__meta:{};_cid++;const h={version:n,cid:_cid,locale:a,fallbackLocale:s,messages:o,modifiers:c,pluralRules:u,missing:m,missingWarn:g,fallbackWarn:_,fallbackFormat:p,unresolving:f,postTranslation:b,processor:E,warnHtmlMessage:d,escapeParameter:O,messageCompiler:T,messageResolver:N,localeFallbacker:S,fallbackContext:F,onWarn:t,__meta:C};return h.datetimeFormats=l,h.numberFormats=i,h.__datetimeFormatters=y,h.__numberFormatters=L,h}function handleMissing(e,t,n,a,r){const{missing:s,onWarn:o}=e;if(null!==s){const a=s(e,n,t,r);return isString(a)?a:t}return t}function updateFallbackLocale(e,t,n){e.__localeChainCache=new Map,e.localeFallbacker(e,n,t)}function isAlmostSameLocale(e,t){return e!==t&&e.split("-")[0]===t.split("-")[0]}function isImplicitFallback(e,t){const n=t.indexOf(e);if(-1===n)return!1;for(let a=n+1;a<t.length;a++)if(isAlmostSameLocale(e,t[a]))return!0;return!1}const isMessageAST=e=>isObject(e)&&(0===e.t||0===e.type)&&("b"in e||"body"in e),NOOP_MESSAGE_FUNCTION=()=>"",isMessageFunction=e=>isFunction(e);function translate(e,...t){const{fallbackFormat:n,postTranslation:a,unresolving:r,messageCompiler:s,fallbackLocale:o,messages:l}=e,[i,c]=parseTranslateArgs(...t),u=isBoolean(c.missingWarn)?c.missingWarn:e.missingWarn,m=isBoolean(c.fallbackWarn)?c.fallbackWarn:e.fallbackWarn,g=isBoolean(c.escapeParameter)?c.escapeParameter:e.escapeParameter,_=!!c.resolvedMessage,p=isString(c.default)||isBoolean(c.default)?isBoolean(c.default)?s?i:()=>i:c.default:n?s?i:()=>i:"",f=n||""!==p,b=getLocale(e,c);g&&escapeParams(c);let[E,d,O]=_?[i,b,l[b]||{}]:resolveMessageFormat(e,i,b,o,m,u),T=E,N=i;if(_||isString(T)||isMessageAST(T)||isMessageFunction(T)||f&&(T=p,N=T),!(_||(isString(T)||isMessageAST(T)||isMessageFunction(T))&&isString(d)))return r?NOT_REOSLVED:i;let S=!1;const F=isMessageFunction(T)?T:compileMessageFormat(e,i,d,T,N,(()=>{S=!0}));if(S)return T;const I=evaluateMessage(e,F,createMessageContext(getMessageContextOptions(e,d,O,c)));return a?a(I,i):I}function escapeParams(e){isArray(e.list)?e.list=e.list.map((e=>isString(e)?escapeHtml(e):e)):isObject(e.named)&&Object.keys(e.named).forEach((t=>{isString(e.named[t])&&(e.named[t]=escapeHtml(e.named[t]))}))}function resolveMessageFormat(e,t,n,a,r,s){const{messages:o,onWarn:l,messageResolver:i,localeFallbacker:c}=e,u=c(e,a,n);let m,g={},_=null;for(let p=0;p<u.length&&(m=u[p],g=o[m]||{},null===(_=i(g,t))&&(_=g[t]),!(isString(_)||isMessageAST(_)||isMessageFunction(_)));p++)if(!isImplicitFallback(m,u)){const n=handleMissing(e,t,m,s,"translate");n!==t&&(_=n)}return[_,m,g]}function compileMessageFormat(e,t,n,a,r,s){const{messageCompiler:o,warnHtmlMessage:l}=e;if(isMessageFunction(a)){const e=a;return e.locale=e.locale||n,e.key=e.key||t,e}if(null==o){const e=()=>a;return e.locale=n,e.key=t,e}const i=o(a,getCompileContext(e,n,r,a,l,s));return i.locale=n,i.key=t,i.source=a,i}function evaluateMessage(e,t,n){return t(n)}function parseTranslateArgs(...e){const[t,n,a]=e,r={};if(!(isString(t)||isNumber(t)||isMessageFunction(t)||isMessageAST(t)))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const s=isNumber(t)?String(t):(isMessageFunction(t),t);return isNumber(n)?r.plural=n:isString(n)?r.default=n:isPlainObject(n)&&!isEmptyObject(n)?r.named=n:isArray(n)&&(r.list=n),isNumber(a)?r.plural=a:isString(a)?r.default=a:isPlainObject(a)&&assign(r,a),[s,r]}function getCompileContext(e,t,n,a,r,s){return{locale:t,key:n,warnHtmlMessage:r,onError:e=>{throw s&&s(e),e},onCacheKey:e=>generateFormatCacheKey(t,n,e)}}function getMessageContextOptions(e,t,n,a){const{modifiers:r,pluralRules:s,messageResolver:o,fallbackLocale:l,fallbackWarn:i,missingWarn:c,fallbackContext:u}=e,m={locale:t,modifiers:r,pluralRules:s,messages:a=>{let r=o(n,a);if(null==r&&u){const[,,e]=resolveMessageFormat(u,a,t,l,i,c);r=o(e,a)}if(isString(r)||isMessageAST(r)){let n=!1;const s=compileMessageFormat(e,a,t,r,a,(()=>{n=!0}));return n?NOOP_MESSAGE_FUNCTION:s}return isMessageFunction(r)?r:NOOP_MESSAGE_FUNCTION}};return e.processor&&(m.processor=e.processor),a.list&&(m.list=a.list),a.named&&(m.named=a.named),isNumber(a.plural)&&(m.pluralIndex=a.plural),m}function datetime(e,...t){const{datetimeFormats:n,unresolving:a,fallbackLocale:r,onWarn:s,localeFallbacker:o}=e,{__datetimeFormatters:l}=e,[i,c,u,m]=parseDateTimeArgs(...t),g=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const _=!!u.part,p=getLocale(e,u),f=o(e,r,p);if(!isString(i)||""===i)return new Intl.DateTimeFormat(p,m).format(c);let b,E={},d=null;for(let N=0;N<f.length&&(b=f[N],E=n[b]||{},d=E[i],!isPlainObject(d));N++)handleMissing(e,i,b,g,"datetime format");if(!isPlainObject(d)||!isString(b))return a?NOT_REOSLVED:i;let O=`${b}__${i}`;isEmptyObject(m)||(O=`${O}__${JSON.stringify(m)}`);let T=l.get(O);return T||(T=new Intl.DateTimeFormat(b,assign({},d,m)),l.set(O,T)),_?T.formatToParts(c):T.format(c)}const DATETIME_FORMAT_OPTIONS_KEYS=["localeMatcher","weekday","era","year","month","day","hour","minute","second","timeZoneName","formatMatcher","hour12","timeZone","dateStyle","timeStyle","calendar","dayPeriod","numberingSystem","hourCycle","fractionalSecondDigits"];function parseDateTimeArgs(...e){const[t,n,a,r]=e,s={};let o,l={};if(isString(t)){const e=t.match(/(\d{4}-\d{2}-\d{2})(T|\s)?(.*)/);if(!e)throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT);const n=e[3]?e[3].trim().startsWith("T")?`${e[1].trim()}${e[3].trim()}`:`${e[1].trim()}T${e[3].trim()}`:e[1].trim();o=new Date(n);try{o.toISOString()}catch(i){throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT)}}else if(isDate(t)){if(isNaN(t.getTime()))throw Error(CoreErrorCodes.INVALID_DATE_ARGUMENT);o=t}else{if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);o=t}return isString(n)?s.key=n:isPlainObject(n)&&Object.keys(n).forEach((e=>{DATETIME_FORMAT_OPTIONS_KEYS.includes(e)?l[e]=n[e]:s[e]=n[e]})),isString(a)?s.locale=a:isPlainObject(a)&&(l=a),isPlainObject(r)&&(l=r),[s.key||"",o,s,l]}function clearDateTimeFormat(e,t,n){const a=e;for(const r in n){const e=`${t}__${r}`;a.__datetimeFormatters.has(e)&&a.__datetimeFormatters.delete(e)}}function number(e,...t){const{numberFormats:n,unresolving:a,fallbackLocale:r,onWarn:s,localeFallbacker:o}=e,{__numberFormatters:l}=e,[i,c,u,m]=parseNumberArgs(...t),g=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const _=!!u.part,p=getLocale(e,u),f=o(e,r,p);if(!isString(i)||""===i)return new Intl.NumberFormat(p,m).format(c);let b,E={},d=null;for(let N=0;N<f.length&&(b=f[N],E=n[b]||{},d=E[i],!isPlainObject(d));N++)handleMissing(e,i,b,g,"number format");if(!isPlainObject(d)||!isString(b))return a?NOT_REOSLVED:i;let O=`${b}__${i}`;isEmptyObject(m)||(O=`${O}__${JSON.stringify(m)}`);let T=l.get(O);return T||(T=new Intl.NumberFormat(b,assign({},d,m)),l.set(O,T)),_?T.formatToParts(c):T.format(c)}const NUMBER_FORMAT_OPTIONS_KEYS=["localeMatcher","style","currency","currencyDisplay","currencySign","useGrouping","minimumIntegerDigits","minimumFractionDigits","maximumFractionDigits","minimumSignificantDigits","maximumSignificantDigits","compactDisplay","notation","signDisplay","unit","unitDisplay","roundingMode","roundingPriority","roundingIncrement","trailingZeroDisplay"];function parseNumberArgs(...e){const[t,n,a,r]=e,s={};let o={};if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const l=t;return isString(n)?s.key=n:isPlainObject(n)&&Object.keys(n).forEach((e=>{NUMBER_FORMAT_OPTIONS_KEYS.includes(e)?o[e]=n[e]:s[e]=n[e]})),isString(a)?s.locale=a:isPlainObject(a)&&(o=a),isPlainObject(r)&&(o=r),[s.key||"",l,s,o]}function clearNumberFormat(e,t,n){const a=e;for(const r in n){const e=`${t}__${r}`;a.__numberFormatters.has(e)&&a.__numberFormatters.delete(e)}}const VERSION="10.0.0-alpha.1",code=CoreErrorCodes.__EXTEND_POINT__,inc=incrementer(code),I18nErrorCodes={UNEXPECTED_RETURN_TYPE:code,INVALID_ARGUMENT:inc(),MUST_BE_CALL_SETUP_TOP:inc(),NOT_INSTALLED:inc(),REQUIRED_VALUE:inc(),INVALID_VALUE:inc(),CANNOT_SETUP_VUE_DEVTOOLS_PLUGIN:inc(),NOT_INSTALLED_WITH_PROVIDE:inc(),UNEXPECTED_ERROR:inc(),NOT_COMPATIBLE_LEGACY_VUE_I18N:inc(),NOT_AVAILABLE_COMPOSITION_IN_LEGACY:inc(),__EXTEND_POINT__:inc()};function createI18nError(e,...t){return createCompileError(e,null,void 0)}const TranslateVNodeSymbol=makeSymbol("__translateVNode"),DatetimePartsSymbol=makeSymbol("__datetimeParts"),NumberPartsSymbol=makeSymbol("__numberParts"),SetPluralRulesSymbol=makeSymbol("__setPluralRules"),InejctWithOptionSymbol=makeSymbol("__injectWithOption"),DisposeSymbol=makeSymbol("__dispose");function handleFlatJson(e){if(!isObject(e))return e;for(const t in e)if(hasOwn(e,t))if(t.includes(".")){const n=t.split("."),a=n.length-1;let r=e,s=!1;for(let e=0;e<a;e++){if(n[e]in r||(r[n[e]]={}),!isObject(r[n[e]])){s=!0;break}r=r[n[e]]}s||(r[n[a]]=e[t],delete e[t]),isObject(r[n[a]])&&handleFlatJson(r[n[a]])}else isObject(e[t])&&handleFlatJson(e[t]);return e}function getLocaleMessages(e,t){const{messages:n,__i18n:a,messageResolver:r,flatJson:s}=t,o=isPlainObject(n)?n:isArray(a)?{}:{[e]:{}};if(isArray(a)&&a.forEach((e=>{if("locale"in e&&"resource"in e){const{locale:t,resource:n}=e;t?(o[t]=o[t]||{},deepCopy(n,o[t])):deepCopy(n,o)}else isString(e)&&deepCopy(JSON.parse(e),o)})),null==r&&s)for(const l in o)hasOwn(o,l)&&handleFlatJson(o[l]);return o}function getComponentOptions(e){return e.type}function adjustI18nResources(e,t,n){let a=isObject(t.messages)?t.messages:{};"__i18nGlobal"in n&&(a=getLocaleMessages(e.locale.value,{messages:a,__i18n:n.__i18nGlobal}));const r=Object.keys(a);if(r.length&&r.forEach((t=>{e.mergeLocaleMessage(t,a[t])})),isObject(t.datetimeFormats)){const n=Object.keys(t.datetimeFormats);n.length&&n.forEach((n=>{e.mergeDateTimeFormat(n,t.datetimeFormats[n])}))}if(isObject(t.numberFormats)){const n=Object.keys(t.numberFormats);n.length&&n.forEach((n=>{e.mergeNumberFormat(n,t.numberFormats[n])}))}}function createTextNode(e){return createVNode(Text,null,e,0)}const DEVTOOLS_META="__INTLIFY_META__",NOOP_RETURN_ARRAY=()=>[],NOOP_RETURN_FALSE=()=>!1;let composerID=0;function defineCoreMissingHandler(e){return(t,n,a,r)=>e(n,a,getCurrentInstance()||void 0,r)}const getMetaInfo=()=>{const e=getCurrentInstance();let t=null;return e&&(t=getComponentOptions(e)[DEVTOOLS_META])?{[DEVTOOLS_META]:t}:null};function createComposer(e={}){const{__root:t,__injectWithOption:n}=e,a=void 0===t,r=e.flatJson,s=inBrowser?ref:shallowRef,o=!!e.translateExistCompatible;let l=!isBoolean(e.inheritLocale)||e.inheritLocale;const i=s(t&&l?t.locale.value:isString(e.locale)?e.locale:DEFAULT_LOCALE),c=s(t&&l?t.fallbackLocale.value:isString(e.fallbackLocale)||isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:i.value),u=s(getLocaleMessages(i.value,e)),m=s(isPlainObject(e.datetimeFormats)?e.datetimeFormats:{[i.value]:{}}),g=s(isPlainObject(e.numberFormats)?e.numberFormats:{[i.value]:{}});let _=t?t.missingWarn:!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,p=t?t.fallbackWarn:!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,f=t?t.fallbackRoot:!isBoolean(e.fallbackRoot)||e.fallbackRoot,b=!!e.fallbackFormat,E=isFunction(e.missing)?e.missing:null,d=isFunction(e.missing)?defineCoreMissingHandler(e.missing):null,O=isFunction(e.postTranslation)?e.postTranslation:null,T=t?t.warnHtmlMessage:!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,N=!!e.escapeParameter;const S=t?t.modifiers:isPlainObject(e.modifiers)?e.modifiers:{};let F,I=e.pluralRules||t&&t.pluralRules;F=(()=>{a&&setFallbackContext(null);const t={version:VERSION,locale:i.value,fallbackLocale:c.value,messages:u.value,modifiers:S,pluralRules:I,missing:null===d?void 0:d,missingWarn:_,fallbackWarn:p,fallbackFormat:b,unresolving:!0,postTranslation:null===O?void 0:O,warnHtmlMessage:T,escapeParameter:N,messageResolver:e.messageResolver,messageCompiler:e.messageCompiler,__meta:{framework:"vue"}};t.datetimeFormats=m.value,t.numberFormats=g.value,t.__datetimeFormatters=isPlainObject(F)?F.__datetimeFormatters:void 0,t.__numberFormatters=isPlainObject(F)?F.__numberFormatters:void 0;const n=createCoreContext(t);return a&&setFallbackContext(n),n})(),updateFallbackLocale(F,i.value,c.value);const y=computed({get:()=>i.value,set:e=>{i.value=e,F.locale=i.value}}),L=computed({get:()=>c.value,set:e=>{c.value=e,F.fallbackLocale=c.value,updateFallbackLocale(F,i.value,e)}}),C=computed((()=>u.value)),h=computed((()=>m.value)),A=computed((()=>g.value));const P=(e,n,r,s,o,l)=>{let _;i.value,c.value,u.value,m.value,g.value;try{0,a||(F.fallbackContext=t?getFallbackContext():void 0),_=e(F)}finally{a||(F.fallbackContext=void 0)}if("translate exists"!==r&&isNumber(_)&&_===NOT_REOSLVED||"translate exists"===r&&!_){const[e,a]=n();return t&&f?s(t):o(e)}if(l(_))return _;throw Error(I18nErrorCodes.UNEXPECTED_RETURN_TYPE)};function k(...e){return P((t=>Reflect.apply(translate,null,[t,...e])),(()=>parseTranslateArgs(...e)),"translate",(t=>Reflect.apply(t.t,t,[...e])),(e=>e),(e=>isString(e)))}const R={normalize:function(e){return e.map((e=>isString(e)||isNumber(e)||isBoolean(e)?createTextNode(String(e)):e))},interpolate:e=>e,type:"vnode"};function v(e){return u.value[e]||{}}composerID++,t&&inBrowser&&(watch(t.locale,(e=>{l&&(i.value=e,F.locale=e,updateFallbackLocale(F,i.value,c.value))})),watch(t.fallbackLocale,(e=>{l&&(c.value=e,F.fallbackLocale=e,updateFallbackLocale(F,i.value,c.value))})));const M={id:composerID,locale:y,fallbackLocale:L,get inheritLocale(){return l},set inheritLocale(e){l=e,e&&t&&(i.value=t.locale.value,c.value=t.fallbackLocale.value,updateFallbackLocale(F,i.value,c.value))},get availableLocales(){return Object.keys(u.value).sort()},messages:C,get modifiers(){return S},get pluralRules(){return I||{}},get isGlobal(){return a},get missingWarn(){return _},set missingWarn(e){_=e,F.missingWarn=_},get fallbackWarn(){return p},set fallbackWarn(e){p=e,F.fallbackWarn=p},get fallbackRoot(){return f},set fallbackRoot(e){f=e},get fallbackFormat(){return b},set fallbackFormat(e){b=e,F.fallbackFormat=b},get warnHtmlMessage(){return T},set warnHtmlMessage(e){T=e,F.warnHtmlMessage=e},get escapeParameter(){return N},set escapeParameter(e){N=e,F.escapeParameter=e},t:k,getLocaleMessage:v,setLocaleMessage:function(e,t){if(r){const n={[e]:t};for(const e in n)hasOwn(n,e)&&handleFlatJson(n[e]);t=n[e]}u.value[e]=t,F.messages=u.value},mergeLocaleMessage:function(e,t){u.value[e]=u.value[e]||{};const n={[e]:t};if(r)for(const a in n)hasOwn(n,a)&&handleFlatJson(n[a]);deepCopy(t=n[e],u.value[e]),F.messages=u.value},getPostTranslationHandler:function(){return isFunction(O)?O:null},setPostTranslationHandler:function(e){O=e,F.postTranslation=e},getMissingHandler:function(){return E},setMissingHandler:function(e){null!==e&&(d=defineCoreMissingHandler(e)),E=e,F.missing=d},[SetPluralRulesSymbol]:function(e){I=e,F.pluralRules=I}};return M.datetimeFormats=h,M.numberFormats=A,M.rt=function(...e){const[t,n,a]=e;if(a&&!isObject(a))throw Error(I18nErrorCodes.INVALID_ARGUMENT);return k(t,n,assign({resolvedMessage:!0},a||{}))},M.te=function(e,t){return P((()=>{if(!e)return!1;const n=v(isString(t)?t:i.value),a=F.messageResolver(n,e);return o?null!=a:isMessageAST(a)||isMessageFunction(a)||isString(a)}),(()=>[e]),"translate exists",(n=>Reflect.apply(n.te,n,[e,t])),NOOP_RETURN_FALSE,(e=>isBoolean(e)))},M.tm=function(e){const n=function(e){let t=null;const n=fallbackWithLocaleChain(F,c.value,i.value);for(let a=0;a<n.length;a++){const r=u.value[n[a]]||{},s=F.messageResolver(r,e);if(null!=s){t=s;break}}return t}(e);return null!=n?n:t&&t.tm(e)||{}},M.d=function(...e){return P((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),"datetime format",(t=>Reflect.apply(t.d,t,[...e])),(()=>MISSING_RESOLVE_VALUE),(e=>isString(e)))},M.n=function(...e){return P((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),"number format",(t=>Reflect.apply(t.n,t,[...e])),(()=>MISSING_RESOLVE_VALUE),(e=>isString(e)))},M.getDateTimeFormat=function(e){return m.value[e]||{}},M.setDateTimeFormat=function(e,t){m.value[e]=t,F.datetimeFormats=m.value,clearDateTimeFormat(F,e,t)},M.mergeDateTimeFormat=function(e,t){m.value[e]=assign(m.value[e]||{},t),F.datetimeFormats=m.value,clearDateTimeFormat(F,e,t)},M.getNumberFormat=function(e){return g.value[e]||{}},M.setNumberFormat=function(e,t){g.value[e]=t,F.numberFormats=g.value,clearNumberFormat(F,e,t)},M.mergeNumberFormat=function(e,t){g.value[e]=assign(g.value[e]||{},t),F.numberFormats=g.value,clearNumberFormat(F,e,t)},M[InejctWithOptionSymbol]=n,M[TranslateVNodeSymbol]=function(...e){return P((t=>{let n;const a=t;try{a.processor=R,n=Reflect.apply(translate,null,[a,...e])}finally{a.processor=null}return n}),(()=>parseTranslateArgs(...e)),"translate",(t=>t[TranslateVNodeSymbol](...e)),(e=>[createTextNode(e)]),(e=>isArray(e)))},M[DatetimePartsSymbol]=function(...e){return P((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),"datetime format",(t=>t[DatetimePartsSymbol](...e)),NOOP_RETURN_ARRAY,(e=>isString(e)||isArray(e)))},M[NumberPartsSymbol]=function(...e){return P((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),"number format",(t=>t[NumberPartsSymbol](...e)),NOOP_RETURN_ARRAY,(e=>isString(e)||isArray(e)))},M}function convertComposerOptions(e){const t=isString(e.locale)?e.locale:DEFAULT_LOCALE,n=isString(e.fallbackLocale)||isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:t,a=isFunction(e.missing)?e.missing:void 0,r=!isBoolean(e.silentTranslationWarn)&&!isRegExp(e.silentTranslationWarn)||!e.silentTranslationWarn,s=!isBoolean(e.silentFallbackWarn)&&!isRegExp(e.silentFallbackWarn)||!e.silentFallbackWarn,o=!isBoolean(e.fallbackRoot)||e.fallbackRoot,l=!!e.formatFallbackMessages,i=isPlainObject(e.modifiers)?e.modifiers:{},c=e.pluralizationRules,u=isFunction(e.postTranslation)?e.postTranslation:void 0,m=!isString(e.warnHtmlInMessage)||"off"!==e.warnHtmlInMessage,g=!!e.escapeParameterHtml,_=!isBoolean(e.sync)||e.sync;let p=e.messages;if(isPlainObject(e.sharedMessages)){const t=e.sharedMessages;p=Object.keys(t).reduce(((e,n)=>{const a=e[n]||(e[n]={});return assign(a,t[n]),e}),p||{})}const{__i18n:f,__root:b,__injectWithOption:E}=e,d=e.datetimeFormats,O=e.numberFormats,T=e.flatJson,N=e.translateExistCompatible;return{locale:t,fallbackLocale:n,messages:p,flatJson:T,datetimeFormats:d,numberFormats:O,missing:a,missingWarn:r,fallbackWarn:s,fallbackRoot:o,fallbackFormat:l,modifiers:i,pluralRules:c,postTranslation:u,warnHtmlMessage:m,escapeParameter:g,messageResolver:e.messageResolver,inheritLocale:_,translateExistCompatible:N,__i18n:f,__root:b,__injectWithOption:E}}function createVueI18n(e={}){const t=createComposer(convertComposerOptions(e)),{__extender:n}=e,a={id:t.id,get locale(){return t.locale.value},set locale(e){t.locale.value=e},get fallbackLocale(){return t.fallbackLocale.value},set fallbackLocale(e){t.fallbackLocale.value=e},get messages(){return t.messages.value},get datetimeFormats(){return t.datetimeFormats.value},get numberFormats(){return t.numberFormats.value},get availableLocales(){return t.availableLocales},get formatter(){return{interpolate:()=>[]}},set formatter(e){},get missing(){return t.getMissingHandler()},set missing(e){t.setMissingHandler(e)},get silentTranslationWarn(){return isBoolean(t.missingWarn)?!t.missingWarn:t.missingWarn},set silentTranslationWarn(e){t.missingWarn=isBoolean(e)?!e:e},get silentFallbackWarn(){return isBoolean(t.fallbackWarn)?!t.fallbackWarn:t.fallbackWarn},set silentFallbackWarn(e){t.fallbackWarn=isBoolean(e)?!e:e},get modifiers(){return t.modifiers},get formatFallbackMessages(){return t.fallbackFormat},set formatFallbackMessages(e){t.fallbackFormat=e},get postTranslation(){return t.getPostTranslationHandler()},set postTranslation(e){t.setPostTranslationHandler(e)},get sync(){return t.inheritLocale},set sync(e){t.inheritLocale=e},get warnHtmlInMessage(){return t.warnHtmlMessage?"warn":"off"},set warnHtmlInMessage(e){t.warnHtmlMessage="off"!==e},get escapeParameterHtml(){return t.escapeParameter},set escapeParameterHtml(e){t.escapeParameter=e},get preserveDirectiveContent(){return!0},set preserveDirectiveContent(e){},get pluralizationRules(){return t.pluralRules||{}},__composer:t,t(...e){const[n,a,r]=e,s={};let o=null,l=null;if(!isString(n))throw Error(I18nErrorCodes.INVALID_ARGUMENT);const i=n;return isString(a)?s.locale=a:isArray(a)?o=a:isPlainObject(a)&&(l=a),isArray(r)?o=r:isPlainObject(r)&&(l=r),Reflect.apply(t.t,t,[i,o||l||{},s])},rt:(...e)=>Reflect.apply(t.rt,t,[...e]),tc(...e){const[n,a,r]=e,s={plural:1};let o=null,l=null;if(!isString(n))throw Error(I18nErrorCodes.INVALID_ARGUMENT);const i=n;return isString(a)?s.locale=a:isNumber(a)?s.plural=a:isArray(a)?o=a:isPlainObject(a)&&(l=a),isString(r)?s.locale=r:isArray(r)?o=r:isPlainObject(r)&&(l=r),Reflect.apply(t.t,t,[i,o||l||{},s])},te:(e,n)=>t.te(e,n),tm:e=>t.tm(e),getLocaleMessage:e=>t.getLocaleMessage(e),setLocaleMessage(e,n){t.setLocaleMessage(e,n)},mergeLocaleMessage(e,n){t.mergeLocaleMessage(e,n)},d:(...e)=>Reflect.apply(t.d,t,[...e]),getDateTimeFormat:e=>t.getDateTimeFormat(e),setDateTimeFormat(e,n){t.setDateTimeFormat(e,n)},mergeDateTimeFormat(e,n){t.mergeDateTimeFormat(e,n)},n:(...e)=>Reflect.apply(t.n,t,[...e]),getNumberFormat:e=>t.getNumberFormat(e),setNumberFormat(e,n){t.setNumberFormat(e,n)},mergeNumberFormat(e,n){t.mergeNumberFormat(e,n)},getChoiceIndex:(e,t)=>-1};return a.__extender=n,a}const baseFormatProps={tag:{type:[String,Object]},locale:{type:String},scope:{type:String,validator:e=>"parent"===e||"global"===e,default:"parent"},i18n:{type:Object}};function getInterpolateArg({slots:e},t){if(1===t.length&&"default"===t[0]){return(e.default?e.default():[]).reduce(((e,t)=>[...e,...t.type===Fragment?t.children:[t]]),[])}return t.reduce(((t,n)=>{const a=e[n];return a&&(t[n]=a()),t}),{})}function getFragmentableTag(){return Fragment}const TranslationImpl=defineComponent({name:"i18n-t",props:assign({keypath:{type:String,required:!0},plural:{type:[Number,String],validator:e=>isNumber(e)||!isNaN(e)}},baseFormatProps),setup(e,t){const{slots:n,attrs:a}=t,r=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return()=>{const s=Object.keys(n).filter((e=>"_"!==e)),o={};e.locale&&(o.locale=e.locale),void 0!==e.plural&&(o.plural=isString(e.plural)?+e.plural:e.plural);const l=getInterpolateArg(t,s),i=r[TranslateVNodeSymbol](e.keypath,l,o),c=assign({},a),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag();return h(u,c,i)}}}),Translation=TranslationImpl,I18nT=Translation;function isVNode(e){return isArray(e)&&!isString(e[0])}function renderFormatter(e,t,n,a){const{slots:r,attrs:s}=t;return()=>{const t={part:!0};let o={};e.locale&&(t.locale=e.locale),isString(e.format)?t.key=e.format:isObject(e.format)&&(isString(e.format.key)&&(t.key=e.format.key),o=Object.keys(e.format).reduce(((t,a)=>n.includes(a)?assign({},t,{[a]:e.format[a]}):t),{}));const l=a(e.value,t,o);let i=[t.key];isArray(l)?i=l.map(((e,t)=>{const n=r[e.type],a=n?n({[e.type]:e.value,index:t,parts:l}):[e.value];return isVNode(a)&&(a[0].key=`${e.type}-${t}`),a})):isString(l)&&(i=[l]);const c=assign({},s),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag();return h(u,c,i)}}const NumberFormatImpl=defineComponent({name:"i18n-n",props:assign({value:{type:Number,required:!0},format:{type:[String,Object]}},baseFormatProps),setup(e,t){const n=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return renderFormatter(e,t,NUMBER_FORMAT_OPTIONS_KEYS,((...e)=>n[NumberPartsSymbol](...e)))}}),NumberFormat=NumberFormatImpl,I18nN=NumberFormat,DatetimeFormatImpl=defineComponent({name:"i18n-d",props:assign({value:{type:[Number,Date],required:!0},format:{type:[String,Object]}},baseFormatProps),setup(e,t){const n=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return renderFormatter(e,t,DATETIME_FORMAT_OPTIONS_KEYS,((...e)=>n[DatetimePartsSymbol](...e)))}}),DatetimeFormat=DatetimeFormatImpl,I18nD=DatetimeFormat;function getComposer$1(e,t){const n=e;if("composition"===e.mode)return n.__getInstance(t)||e.global;{const a=n.__getInstance(t);return null!=a?a.__composer:e.global.__composer}}function vTDirective(e){const t=t=>{const{instance:n,modifiers:a,value:r}=t;if(!n||!n.$)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const s=getComposer$1(e,n.$),o=parseValue(r);return[Reflect.apply(s.t,s,[...makeParams(o)]),s]};return{created:(n,a)=>{const[r,s]=t(a);inBrowser&&e.global===s&&(n.__i18nWatcher=watch(s.locale,(()=>{a.instance&&a.instance.$forceUpdate()}))),n.__composer=s,n.textContent=r},unmounted:e=>{inBrowser&&e.__i18nWatcher&&(e.__i18nWatcher(),e.__i18nWatcher=void 0,delete e.__i18nWatcher),e.__composer&&(e.__composer=void 0,delete e.__composer)},beforeUpdate:(e,{value:t})=>{if(e.__composer){const n=e.__composer,a=parseValue(t);e.textContent=Reflect.apply(n.t,n,[...makeParams(a)])}},getSSRProps:e=>{const[n]=t(e);return{textContent:n}}}}function parseValue(e){if(isString(e))return{path:e};if(isPlainObject(e)){if(!("path"in e))throw Error(I18nErrorCodes.REQUIRED_VALUE,"path");return e}throw Error(I18nErrorCodes.INVALID_VALUE)}function makeParams(e){const{path:t,locale:n,args:a,choice:r,plural:s}=e,o={},l=a||{};return isString(n)&&(o.locale=n),isNumber(r)&&(o.plural=r),isNumber(s)&&(o.plural=s),[t,l,o]}function apply(e,t,...n){const a=isPlainObject(n[0])?n[0]:{},r=!!a.useI18nComponentName;(!isBoolean(a.globalInstall)||a.globalInstall)&&([r?"i18n":Translation.name,"I18nT"].forEach((t=>e.component(t,Translation))),[NumberFormat.name,"I18nN"].forEach((t=>e.component(t,NumberFormat))),[DatetimeFormat.name,"I18nD"].forEach((t=>e.component(t,DatetimeFormat)))),e.directive("t",vTDirective(t))}function defineMixin(e,t,n){return{beforeCreate(){const a=getCurrentInstance();if(!a)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const r=this.$options;if(r.i18n){const a=r.i18n;if(r.__i18n&&(a.__i18n=r.__i18n),a.__root=t,this===this.$root)this.$i18n=mergeToGlobal(e,a);else{a.__injectWithOption=!0,a.__extender=n.__vueI18nExtend,this.$i18n=createVueI18n(a);const e=this.$i18n;e.__extender&&(e.__disposer=e.__extender(this.$i18n))}}else if(r.__i18n)if(this===this.$root)this.$i18n=mergeToGlobal(e,r);else{this.$i18n=createVueI18n({__i18n:r.__i18n,__injectWithOption:!0,__extender:n.__vueI18nExtend,__root:t});const e=this.$i18n;e.__extender&&(e.__disposer=e.__extender(this.$i18n))}else this.$i18n=e;r.__i18nGlobal&&adjustI18nResources(t,r,r),this.$t=(...e)=>this.$i18n.t(...e),this.$rt=(...e)=>this.$i18n.rt(...e),this.$tc=(...e)=>this.$i18n.tc(...e),this.$te=(e,t)=>this.$i18n.te(e,t),this.$d=(...e)=>this.$i18n.d(...e),this.$n=(...e)=>this.$i18n.n(...e),this.$tm=e=>this.$i18n.tm(e),n.__setInstance(a,this.$i18n)},mounted(){},unmounted(){const e=getCurrentInstance();if(!e)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const t=this.$i18n;delete this.$t,delete this.$rt,delete this.$tc,delete this.$te,delete this.$d,delete this.$n,delete this.$tm,t.__disposer&&(t.__disposer(),delete t.__disposer,delete t.__extender),n.__deleteInstance(e),delete this.$i18n}}}function mergeToGlobal(e,t){e.locale=t.locale||e.locale,e.fallbackLocale=t.fallbackLocale||e.fallbackLocale,e.missing=t.missing||e.missing,e.silentTranslationWarn=t.silentTranslationWarn||e.silentFallbackWarn,e.silentFallbackWarn=t.silentFallbackWarn||e.silentFallbackWarn,e.formatFallbackMessages=t.formatFallbackMessages||e.formatFallbackMessages,e.postTranslation=t.postTranslation||e.postTranslation,e.warnHtmlInMessage=t.warnHtmlInMessage||e.warnHtmlInMessage,e.escapeParameterHtml=t.escapeParameterHtml||e.escapeParameterHtml,e.sync=t.sync||e.sync,e.__composer[SetPluralRulesSymbol](t.pluralizationRules||e.pluralizationRules);const n=getLocaleMessages(e.locale,{messages:t.messages,__i18n:t.__i18n});return Object.keys(n).forEach((t=>e.mergeLocaleMessage(t,n[t]))),t.datetimeFormats&&Object.keys(t.datetimeFormats).forEach((n=>e.mergeDateTimeFormat(n,t.datetimeFormats[n]))),t.numberFormats&&Object.keys(t.numberFormats).forEach((n=>e.mergeNumberFormat(n,t.numberFormats[n]))),e}const I18nInjectionKey=makeSymbol("global-vue-i18n");function createI18n(e={},t){const n=!isBoolean(e.legacy)||e.legacy,a=!isBoolean(e.globalInjection)||e.globalInjection,r=new Map,[s,o]=createGlobal(e,n),l=makeSymbol("");const i={get mode(){return n?"legacy":"composition"},async install(e,...t){if(e.__VUE_I18N_SYMBOL__=l,e.provide(e.__VUE_I18N_SYMBOL__,i),isPlainObject(t[0])){const e=t[0];i.__composerExtend=e.__composerExtend,i.__vueI18nExtend=e.__vueI18nExtend}let r=null;!n&&a&&(r=injectGlobalFields(e,i.global)),apply(e,i,...t),n&&e.mixin(defineMixin(o,o.__composer,i));const s=e.unmount;e.unmount=()=>{r&&r(),i.dispose(),s()}},get global(){return o},dispose(){s.stop()},__instances:r,__getInstance:function(e){return r.get(e)||null},__setInstance:function(e,t){r.set(e,t)},__deleteInstance:function(e){r.delete(e)}};return i}function useI18n(e={}){const t=getCurrentInstance();if(null==t)throw Error(I18nErrorCodes.MUST_BE_CALL_SETUP_TOP);if(!t.isCE&&null!=t.appContext.app&&!t.appContext.app.__VUE_I18N_SYMBOL__)throw Error(I18nErrorCodes.NOT_INSTALLED);const n=getI18nInstance(t),a=getGlobalComposer(n),r=getComponentOptions(t),s=getScope(e,r);if("global"===s)return adjustI18nResources(a,e,r),a;if("parent"===s){let r=getComposer(n,t,e.__useComponent);return null==r&&(r=a),r}const o=n;let l=o.__getInstance(t);if(null==l){const n=assign({},e);"__i18n"in r&&(n.__i18n=r.__i18n),a&&(n.__root=a),l=createComposer(n),o.__composerExtend&&(l[DisposeSymbol]=o.__composerExtend(l)),setupLifeCycle(o,t,l),o.__setInstance(t,l)}return l}function createGlobal(e,t,n){const a=effectScope(),r=t?a.run((()=>createVueI18n(e))):a.run((()=>createComposer(e)));if(null==r)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);return[a,r]}function getI18nInstance(e){const t=inject(e.isCE?I18nInjectionKey:e.appContext.app.__VUE_I18N_SYMBOL__);if(!t)throw createI18nError(e.isCE?I18nErrorCodes.NOT_INSTALLED_WITH_PROVIDE:I18nErrorCodes.UNEXPECTED_ERROR);return t}function getScope(e,t){return isEmptyObject(e)?"__i18n"in t?"local":"global":e.useScope?e.useScope:"local"}function getGlobalComposer(e){return"composition"===e.mode?e.global:e.global.__composer}function getComposer(e,t,n=!1){let a=null;const r=t.root;let s=getParentComponentInstance(t,n);for(;null!=s;){const t=e;if("composition"===e.mode)a=t.__getInstance(s);else{const e=t.__getInstance(s);null!=e&&(a=e.__composer,n&&a&&!a[InejctWithOptionSymbol]&&(a=null))}if(null!=a)break;if(r===s)break;s=s.parent}return a}function getParentComponentInstance(e,t=!1){return null==e?null:t&&e.vnode.ctx||e.parent}function setupLifeCycle(e,t,n){onMounted((()=>{}),t),onUnmounted((()=>{const a=n;e.__deleteInstance(t);const r=a[DisposeSymbol];r&&(r(),delete a[DisposeSymbol])}),t)}const globalExportProps=["locale","fallbackLocale","availableLocales"],globalExportMethods=["t","rt","d","n","tm","te"];function injectGlobalFields(e,t){const n=Object.create(null);globalExportProps.forEach((e=>{const a=Object.getOwnPropertyDescriptor(t,e);if(!a)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const r=isRef(a.value)?{get:()=>a.value.value,set(e){a.value.value=e}}:{get:()=>a.get&&a.get()};Object.defineProperty(n,e,r)})),e.config.globalProperties.$i18n=n,globalExportMethods.forEach((n=>{const a=Object.getOwnPropertyDescriptor(t,n);if(!a||!a.value)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);Object.defineProperty(e.config.globalProperties,`$${n}`,a)}));return()=>{delete e.config.globalProperties.$i18n,globalExportMethods.forEach((t=>{delete e.config.globalProperties[`$${t}`]}))}}export{DatetimeFormat,I18nD,I18nInjectionKey,I18nN,I18nT,NumberFormat,Translation,VERSION,createI18n,useI18n,vTDirective};
